<template>
  <div class="mh-users-page">
    <div
      v-for="(user, index) in users"
      :key="index"
      class="mh-users-page__user"
    >
      <div
        class="mh-users-page__user-name"
        @click="$router.push({ path: '/users/edit/' + user.id })"
      >
        {{ user.name + ' ' + user.surname }}
      </div>

      <mh-button @click="handleUserDelete(user.id)">
        {{ $t('pages.remove') }}
      </mh-button>
    </div>

    <mh-button @click="$router.push({ name: 'new-user' })">
      {{ $t('pages.new_user') }}
    </mh-button>
  </div>
</template>

<script>
import UsersApi from '@/api/users'

import MhButton from '@/components/controls/button'

export default {
  name: 'MhUsers',

  components: { MhButton },

  data() {
    return {
      users: []
    }
  },

  mounted() {
    this.getUsers.bind(this)().then(users => {
      this.users = users
    })
  },

  methods: {
    ...UsersApi,

    handleUserDelete(id) {
      this.deleteUser(id).then(() => {
        this.users = this.users.filter(user => user.id !== id)
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.mh-users-page {
  padding:  0 $base-layout-padding;

  &__user {
    display: flex;
    gap: 15px;
    align-items: center;
    margin: 15px 0;
  }

  &__user-name {
    transition: 0.3s ease;
    cursor: pointer;

    &:hover {
      color: lighten($darken, 20%)
    }
  }
}
</style>
